/* 
 This file was generated by Dashcode.  
 You may edit this file to customize your widget or web page 
 according to the license.txt file included in the project.
 */

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    dashcode.setupParts();
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}

$(document).ready(function(){
    requestUpdate();
});

function requestUpdate() {
    $.getJSON('http://plipr.com/phpsysinfo/json.php', function(data) {
        $('#uptime').text(timeSince(data.Vitals.Uptime));
        $('#eth').html( bytesToSize(data.Network.eth0.RxBytes) + '<br>' + bytesToSize(data.Network.eth0.TxBytes) );
        $('#wlan').html( bytesToSize(data.Network.wlan0.RxBytes) + '<br>' + bytesToSize(data.Network.wlan0.TxBytes) );
        var fs_array = data.FileSystem;
        var raid = [];
        $.each(fs_array, function() {
            if(this.Name=='/dev/md127') {
                raid = this;
            }
        });
        progressCircle(raid.Used/raid.Total);
    });
}

function timeSince(t){
    t = parseInt(t);
	var days = parseInt(t/86400);
	t = t-(days*86400);
	var hours = parseInt(t/3600);
	t = t-(hours*3600);
	var minutes = parseInt(t/60);
	t = t-(minutes*60);
	var content = "";
	if(days)content+=days+"d";
	if(hours||days){ if(content)content+=" "; content+=hours+"h"; }
	if(content)content+=" "; content+=minutes+"m "+t+"s";
	return content;
}

function bytesToSize(bytes) {
  var sizes = ['B', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB'];
  if (bytes == 0) return 'n/a';
  var i = parseInt(Math.floor(Math.log(bytes) / Math.log(1024)));
  return ((i == 0)? (bytes / Math.pow(1024, i)) : (bytes / Math.pow(1024, i)).toFixed(2)) + ' ' + sizes[i];
};


function progressCircle(current_value) {
    var bg = document.getElementById('counter');
    var ctx = bg.getContext('2d');
    var imd = null;
    var circ = Math.PI * 2;
    var quart = Math.PI / 2;
    var bgWidth = $(bg).width();
    var bgHeight = $(bg).height();
    var radius = 30;

    imd = ctx.getImageData(0, 0, bgWidth, bgHeight);

    var draw = function(current) {
        ctx.putImageData(imd, 0, 0);
        drawCirclePath();
        ctx.beginPath();
        ctx.strokeStyle = '#9C3';
        // ctx.shadowOffsetX = 0;
        // ctx.shadowOffsetY = 0;
        // ctx.shadowBlur = 10;
        // ctx.shadowColor = "rgba(153, 204, 51, 0.6)";
        ctx.closePath();
        ctx.fill();
        ctx.lineWidth = 8;
        ctx.arc(bgWidth/2, bgHeight/2, radius, -(quart), ((circ) * current) - quart, false);
        ctx.stroke();
    }
    
    var drawCirclePath = function() {
        ctx.beginPath();
        ctx.strokeStyle = '#222';
        ctx.shadowOffsetX = 0;
        ctx.shadowOffsetY = 1;
        ctx.shadowBlur = 0;
        ctx.shadowColor = 'rgba(255,255,255,0.33)';
        ctx.closePath();
        ctx.fill();
        ctx.lineWidth = 10.0;
        ctx.arc(bgWidth/2, bgHeight/2, radius, -(quart), ((circ) * 100) - quart, false);
        ctx.stroke();
    }
    
    draw(current_value);
}